#! /usr/bin/python
# -- coding: utf-8 --

# Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS

# This software is published by the license of CPU-OS License, you can use and 
# distibuted this software under this License. See CPU-OS Liense for more detail.

# You should have receive a copy of CPU-OS License. If not, please contact us 
# by email <support_os@cpu-os.ac.cn>  

import sqlite3
import sys
from packageinfo import PackageInfo
import logging

global current_path
current_path = sys.path[0] + '/software_center/'
if __name__ == '__main__':
    current_path = sys.path[0] + '/'

database_file = "softwarecenter2.db"

class AptDatabase():
    def __init__(self):
        pass
        
    def update(self):
        pass
    
    def get_version(self):
        version = None
        conn = None
        try:
            conn = sqlite3.connect(current_path + database_file)
            cs = conn.cursor()
            itr = cs.execute("SELECT * FROM version")
            for value in itr:
                version = value[0]
        except Exception as e:
            logging.error(str(e))
            # logging.error()
        finally:
            if conn is not None:
                conn.close()

        return version

    def search_software(self, name):
        conn = None
        try:
            conn = sqlite3.connect(current_path + database_file)
            cs = conn.cursor()
            command = "SELECT software,title,cversion,short_desc,long_desc FROM isoftware WHERE software = '%s'" % name 
            itr = cs.execute(command)
            for value in itr:
                pkg = { }
                pkg['Package'] = value[0]
                pkg['AppName'] = value[1]
                pkg['Version'] = value[2]
                pkg['ShortDesc'] = value[3]
                pkg['LongDesc'] = value[4]
                return pkg
        except Exception as e:
            logging.error(str(e))
        finally:
            if conn is not None:
                conn.close()
        return None

    def search_software_list(self, name_list):
        conn = None
        try:
            conn = sqlite3.connect(current_path + database_file)
            cs = conn.cursor()
            pattern = "SELECT software,title,cversion,short_desc,long_desc FROM isoftware WHERE software = '%s'"
            for name in name_list :
                command = pattern % name
                itr = cs.execute(command)
                for value in itr:
                    pkg = { }
                    pkg['Package'] = value[0]
                    pkg['AppName'] = value[1]
                    pkg['Version'] = value[2]
                    pkg['ShortDesc'] = value[3]
                    pkg['LongDesc'] = value[4]
                    yield pkg
        except Exception as e:
            logging.error(str(e))
        finally:
            if conn is not None:
                conn.close()

    def list_software_names(self):
        res = []
        conn = None
        try:
            conn = sqlite3.connect(current_path + database_file)
            cs = conn.cursor()
            itr = cs.execute("SELECT software FROM isoftware")
            for value in itr:
                res.append(value[0])
        except Exception as e:
            logging.error(str(e))
        finally:
            if conn is not None:
                conn.close()
        return res

    #从软件中心数据库返回所有软件的软件包名，名称，版本，简述和详细描述.
    def list_all_softwares(self):
        conn = None
        try:
            conn = sqlite3.connect(current_path + database_file)
            cs = conn.cursor()
            itr = cs.execute("SELECT software,title,cversion,short_desc,long_desc FROM isoftware")
            for value in itr:
                pkg = { }
                pkg['Package'] = value[0]
                pkg['AppName'] = value[1]
                pkg['Version'] = value[2]
                pkg['ShortDesc'] = value[3]
                pkg['LongDesc'] = value[4]
                yield pkg
        except Exception as e:
            logging.error(str(e))
        finally:
            if conn is not None:
                conn.close()

if __name__ == '__main__':
    db = AptDatabase()
    print( db.get_version() )

    pkg = db.search_software("altos")
    print( pkg )

    for pkg in db.search_software_list(["altos", "kazam", "code"]):
        print( pkg )

    for pkg in db.list_all_softwares() :
       print( pkg )
       break