#! /usr/bin/python
# -- coding: utf-8 --

# Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS

# This software is published by the license of CPU-OS License, you can use and 
# distibuted this software under this License. See CPU-OS Liense for more detail.

# You should have receive a copy of CPU-OS License. If not, please contact us 
# by email <support_os@cpu-os.ac.cn>  

import ConfigParser
import sys
import urllib
import subprocess

import apt_database
import logging

global current_path
current_path = sys.path[0] + '/software_center/'
if __name__ == '__main__':
    current_path = sys.path[0] + '/'

config_file   = 'ServerConfig.ini'
download_file = 'softcenterdbs.tar.gz'
extract_bash  = 'app_data_unpack.sh'

class SoftwareCenterServer():
    def __init__(self):
        config = ConfigParser.ConfigParser()
        try:
            global current_path
            config.readfp(open( current_path + config_file))
            self.__reset__( config )
        except Exception as e:
            logging.error(str(e))

    def __reset__(self, config):
        group = "ServerConfig1"
        self.baseUrl = config.get(group, "baseUrl")
        self.dataBaseUpdateUrl = config.get(group, "dataBaseUpdateUrl")

    def update_server_config(self):
        pass

    def get_url(self):
        return self.baseUrl

    def get_database_url(self):
        return self.dataBaseUpdateUrl
    
    def download_new_database(self):
        db = apt_database.AptDatabase()
        version = db.get_version()
        if version is None:
            version = 1
        url = self.dataBaseUpdateUrl + str(version) + "/cdos"
        res = None
        try:
            res = urllib.urlopen(url)
        except Exception as e:
            logging.error(str(e))
            return False

        content = str(res.read())
        if content == 'fail' or content == '{"result":"success}' or content == '{"result":"failure"}':
            return False

        global current_path
        with open( current_path + download_file, 'w') as f:
            f.write(content)
            f.flush()
        
        errput = subprocess.Popen([(current_path + extract_bash), current_path, download_file], shell=False, stdout=subprocess.PIPE)
        while subprocess.Popen.poll(errput) is None:
            line = errput.stdout.readline()
            if line == 'success\n':
                return True

        return False

        
if __name__ == '__main__':
    server = SoftwareCenterServer()
    server.download_new_database()
